// Generated by PeakRDL-regblock - A free and open-source SystemVerilog generator
//  https://github.com/SystemRDL/PeakRDL-regblock

module m2s_dma_regs (
        input wire clk,
        input wire rst,

        input wire s_cpuif_req,
        input wire s_cpuif_req_is_wr,
        input wire [3:0] s_cpuif_addr,
        input wire [31:0] s_cpuif_wr_data,
        input wire [31:0] s_cpuif_wr_biten,
        output wire s_cpuif_req_stall_wr,
        output wire s_cpuif_req_stall_rd,
        output wire s_cpuif_rd_ack,
        output wire s_cpuif_rd_err,
        output wire [31:0] s_cpuif_rd_data,
        output wire s_cpuif_wr_ack,
        output wire s_cpuif_wr_err,

        input m2s_dma_regs_pkg::m2s_dma_regs__in_t hwif_in,
        output m2s_dma_regs_pkg::m2s_dma_regs__out_t hwif_out
    );

    //--------------------------------------------------------------------------
    // CPU Bus interface logic
    //--------------------------------------------------------------------------
    logic cpuif_req;
    logic cpuif_req_is_wr;
    logic [3:0] cpuif_addr;
    logic [31:0] cpuif_wr_data;
    logic [31:0] cpuif_wr_biten;
    logic cpuif_req_stall_wr;
    logic cpuif_req_stall_rd;

    logic cpuif_rd_ack;
    logic cpuif_rd_err;
    logic [31:0] cpuif_rd_data;

    logic cpuif_wr_ack;
    logic cpuif_wr_err;

    assign cpuif_req = s_cpuif_req;
    assign cpuif_req_is_wr = s_cpuif_req_is_wr;
    assign cpuif_addr = s_cpuif_addr;
    assign cpuif_wr_data = s_cpuif_wr_data;
    assign cpuif_wr_biten = s_cpuif_wr_biten;
    assign s_cpuif_req_stall_wr = cpuif_req_stall_wr;
    assign s_cpuif_req_stall_rd = cpuif_req_stall_rd;
    assign s_cpuif_rd_ack = cpuif_rd_ack;
    assign s_cpuif_rd_err = cpuif_rd_err;
    assign s_cpuif_rd_data = cpuif_rd_data;
    assign s_cpuif_wr_ack = cpuif_wr_ack;
    assign s_cpuif_wr_err = cpuif_wr_err;

    logic cpuif_req_masked;

    // Read & write latencies are balanced. Stalls not required
    assign cpuif_req_stall_rd = '0;
    assign cpuif_req_stall_wr = '0;
    assign cpuif_req_masked = cpuif_req
                            & !(!cpuif_req_is_wr & cpuif_req_stall_rd)
                            & !(cpuif_req_is_wr & cpuif_req_stall_wr);

    //--------------------------------------------------------------------------
    // Address Decode
    //--------------------------------------------------------------------------
    typedef struct {
        logic curr_addr;
        logic end_addr;
        logic dma_done;
        logic ctrl;
    } decoded_reg_strb_t;
    decoded_reg_strb_t decoded_reg_strb;
    logic decoded_req;
    logic decoded_req_is_wr;
    logic [31:0] decoded_wr_data;
    logic [31:0] decoded_wr_biten;

    always_comb begin
        decoded_reg_strb.curr_addr = cpuif_req_masked & (cpuif_addr == 4'h0);
        decoded_reg_strb.end_addr = cpuif_req_masked & (cpuif_addr == 4'h4);
        decoded_reg_strb.dma_done = cpuif_req_masked & (cpuif_addr == 4'h8);
        decoded_reg_strb.ctrl = cpuif_req_masked & (cpuif_addr == 4'hc);
    end

    // Pass down signals to next stage
    assign decoded_req = cpuif_req_masked;
    assign decoded_req_is_wr = cpuif_req_is_wr;
    assign decoded_wr_data = cpuif_wr_data;
    assign decoded_wr_biten = cpuif_wr_biten;

    //--------------------------------------------------------------------------
    // Field logic
    //--------------------------------------------------------------------------
    typedef struct {
        struct {
            struct {
                logic [31:0] next;
                logic load_next;
            } d;
        } curr_addr;
        struct {
            struct {
                logic [31:0] next;
                logic load_next;
            } d;
        } end_addr;
        struct {
            struct {
                logic next;
                logic load_next;
            } swreset;
        } ctrl;
    } field_combo_t;
    field_combo_t field_combo;

    typedef struct {
        struct {
            struct {
                logic [31:0] value;
            } d;
        } curr_addr;
        struct {
            struct {
                logic [31:0] value;
            } d;
        } end_addr;
        struct {
            struct {
                logic value;
            } swreset;
        } ctrl;
    } field_storage_t;
    field_storage_t field_storage;

    // Field: m2s_dma_regs.curr_addr.d
    always_comb begin
        automatic logic [31:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.curr_addr.d.value;
        load_next_c = '0;
        if(decoded_reg_strb.curr_addr && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.curr_addr.d.value & ~decoded_wr_biten[31:0]) | (decoded_wr_data[31:0] & decoded_wr_biten[31:0]);
            load_next_c = '1;
        end else begin // HW Write
            next_c = hwif_in.curr_addr.d.next;
            load_next_c = '1;
        end
        field_combo.curr_addr.d.next = next_c;
        field_combo.curr_addr.d.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.curr_addr.d.value <= 32'h0;
        end else if(field_combo.curr_addr.d.load_next) begin
            field_storage.curr_addr.d.value <= field_combo.curr_addr.d.next;
        end
    end
    assign hwif_out.curr_addr.d.value = field_storage.curr_addr.d.value;
    // Field: m2s_dma_regs.end_addr.d
    always_comb begin
        automatic logic [31:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.end_addr.d.value;
        load_next_c = '0;
        if(decoded_reg_strb.end_addr && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.end_addr.d.value & ~decoded_wr_biten[31:0]) | (decoded_wr_data[31:0] & decoded_wr_biten[31:0]);
            load_next_c = '1;
        end else if(hwif_in.end_addr.d.hwclr) begin // HW Clear
            next_c = '0;
            load_next_c = '1;
        end
        field_combo.end_addr.d.next = next_c;
        field_combo.end_addr.d.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.end_addr.d.value <= 32'h0;
        end else if(field_combo.end_addr.d.load_next) begin
            field_storage.end_addr.d.value <= field_combo.end_addr.d.next;
        end
    end
    assign hwif_out.end_addr.d.value = field_storage.end_addr.d.value;
    assign hwif_out.end_addr.d.swmod = decoded_reg_strb.end_addr && decoded_req_is_wr;
    // Field: m2s_dma_regs.ctrl.swreset
    always_comb begin
        automatic logic [0:0] next_c;
        automatic logic load_next_c;
        next_c = field_storage.ctrl.swreset.value;
        load_next_c = '0;
        if(decoded_reg_strb.ctrl && decoded_req_is_wr) begin // SW write
            next_c = (field_storage.ctrl.swreset.value & ~decoded_wr_biten[0:0]) | (decoded_wr_data[0:0] & decoded_wr_biten[0:0]);
            load_next_c = '1;
        end
        field_combo.ctrl.swreset.next = next_c;
        field_combo.ctrl.swreset.load_next = load_next_c;
    end
    always_ff @(posedge clk) begin
        if(rst) begin
            field_storage.ctrl.swreset.value <= 1'h1;
        end else if(field_combo.ctrl.swreset.load_next) begin
            field_storage.ctrl.swreset.value <= field_combo.ctrl.swreset.next;
        end
    end
    assign hwif_out.ctrl.swreset.value = field_storage.ctrl.swreset.value;

    //--------------------------------------------------------------------------
    // Write response
    //--------------------------------------------------------------------------
    assign cpuif_wr_ack = decoded_req & decoded_req_is_wr;
    // Writes are always granted with no error response
    assign cpuif_wr_err = '0;

    //--------------------------------------------------------------------------
    // Readback
    //--------------------------------------------------------------------------

    logic readback_err;
    logic readback_done;
    logic [31:0] readback_data;

    // Assign readback values to a flattened array
    logic [31:0] readback_array[4];
    assign readback_array[0][31:0] = (decoded_reg_strb.curr_addr && !decoded_req_is_wr) ? field_storage.curr_addr.d.value : '0;
    assign readback_array[1][31:0] = (decoded_reg_strb.end_addr && !decoded_req_is_wr) ? field_storage.end_addr.d.value : '0;
    assign readback_array[2][31:0] = (decoded_reg_strb.dma_done && !decoded_req_is_wr) ? hwif_in.dma_done.d.next : '0;
    assign readback_array[3][0:0] = (decoded_reg_strb.ctrl && !decoded_req_is_wr) ? field_storage.ctrl.swreset.value : '0;
    assign readback_array[3][31:1] = '0;

    // Reduce the array
    always_comb begin
        automatic logic [31:0] readback_data_var;
        readback_done = decoded_req & ~decoded_req_is_wr;
        readback_err = '0;
        readback_data_var = '0;
        for(int i=0; i<4; i++) readback_data_var |= readback_array[i];
        readback_data = readback_data_var;
    end

    assign cpuif_rd_ack = readback_done;
    assign cpuif_rd_data = readback_data;
    assign cpuif_rd_err = readback_err;
endmodule
